unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    ListBox1: TListBox;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// Tours de Hanoi drcursifi

var piq:array[1..3,1..10] of integer; // les piquets, pour le dessin
    n:integer; // nb de disques

function Disque_du_haut(piquet:integer):integer;
begin
     result:=10;
     while (result>=1) and (piq[piquet,result]=0) do dec(result);
end;

procedure bouge(d,a:integer);
begin
     piq[a,Disque_du_haut(a)+1]:=piq[d,Disque_du_haut(d)]; // mettre le disque sur le piquet arrive
     piq[d,Disque_du_haut(d)]:=0; // l'enlever du piquet dpart
end;

procedure InitPiquets;
var k:integer;
begin
     // initialiser les piquets, pour le dessin
     for k:=1 to n do piq[1,k]:=n-k+1;
     if n<10 then for k:=n+1 to 10 do piq[1,k]:=0;
     for k:=1 to 10 do
         begin
              piq[2,k]:=0;
              piq[3,k]:=0;
         end;
end;

procedure Dessine;
var largeur,coeff,haut,bas,i,p:integer; milieu:array[1..3] of integer;  s:string;
begin
     InitPiquets; // initialiser les piquets, pour le dessin
     // simule les mouvements successifs
     if Form1.ListBox1.ItemIndex>0 then // si pas situation de dpart
        for i:=1 to Form1.ListBox1.ItemIndex do
            begin
                 s:=Form1.ListBox1.Items[i];
                 bouge(StrToInt(s[1]),StrToInt(s[length(s)]));
            end;

     largeur:=Form1.Image1.Width div 3;
     coeff:=((largeur div 2)-10) div n;
     milieu[1]:=largeur div 2;
     milieu[2]:=largeur+(largeur div 2);
     milieu[3]:=2*largeur+(largeur div 2);
     haut:=20;
     bas:=Form1.Image1.Height-20;
     with Form1.Image1.Canvas do begin
          Brush.Color:=clWhite;
          Pen.Color:=clWhite;
          Rectangle(0,0,Form1.Image1.Width,Form1.Image1.Height); // effacer
          for p:=1 to 3 do begin
              Pen.Color:=clRed;
              Pen.Width:=6;
              for i:=1 to 10 do
              if piq[p,i]>0 then
                 begin
                      MoveTo(milieu[p]-piq[p,i]*coeff,bas-4*Pen.Width*(i-1));
                      LineTo(milieu[p]+piq[p,i]*coeff,bas-4*Pen.Width*(i-1));
                 end;
              Pen.Color:=clBlack;
              Pen.Width:=3;
              MoveTo(milieu[p],haut); LineTo(milieu[p],bas);
          end;
     end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var m,k,p:integer;  t,sens:byte; mouv,c:char;  H,s:string;
begin
     Screen.Cursor:=crHourGlass;
     ListBox1.Clear;

     n:=SpinEdit1.Value; // nb de disques  dplacer

     m:=1; // nb de mouvements
     for k:=1 to n do m:=2*m;  // m=2^n
     dec(m); // m=2^n-1

     H:=''; // la suite des mouvements
     for k:=0 to m-1 do  // pour chaque mouvement
         begin
              t:=k mod 3; // donne le type du mouvement
              case t of
                   0:mouv:='A';
                   1:mouv:='C';
                   2:mouv:='B';
              end;

              sens:=k mod 4; // donne le sens du mouvement
              case sens of
                   0: H:=H+mouv;              // k=4p   (mouvement "majuscule")
                   1: H:=H+LowerCase(mouv);   // k=4p+1 (mouvement "minuscule")
                   2: H:=H+mouv;              // k=4p+2 (mouvement "majuscule")
                   3: begin                   // k=4p+3
                         // il faut dterminer le sens du mouvement d'indice p
                         p:=(k-3) div 4;
                         c:=H[p+1]; // dans les chanes, a commence  1...
                         if UpperCase(c)=c then H:=H+mouv // mouvement "majuscule"
                         else H:=H+LowerCase(mouv);       // mouvement "minuscule"
                      end;
              end;
         end;

     ListBox1.Items.Add('Dbut');
     // une petite boucle pour "dcoder" la chane H
     for k:=1 to length(H) do
         begin
              s:='';
              if H[k]='A' then s:=s+'1 vers 2';
              if H[k]='a' then s:=s+'2 vers 1';
              if H[k]='B' then s:=s+'2 vers 3';
              if H[k]='b' then s:=s+'3 vers 2';
              if H[k]='C' then s:=s+'3 vers 1';
              if H[k]='c' then s:=s+'1 vers 3';
              ListBox1.Items.Add(s);
         end;
     ListBox1.Enabled:=true;
     ListBox1.Cursor:=crHandPoint;
     ListBox1.ItemIndex:=0;
     ListBox1Click(Self);
     Screen.Cursor:=crDefault;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
     Dessine;
end;

end.
